#ifndef __MPU_H__
#define __MPU_H__
#include "sndcard.hpp"

class MPU : public Soundcard
{
public:
  MPU();
  virtual ~MPU();

  static Soundcard* recognize();  // if it is compatible then create soundcard

  virtual int reset();
  virtual void startinput();
  virtual void stopinput();

  virtual int hear(unsigned char* buf, int maxlen);
  virtual int play(unsigned char* buf, int len);

protected:

  static int resetmpu();
  static int getmpu(int port, int aftertimeout = 0);  // -1 if not avail
  static int putmpu(int port, unsigned char c);

  virtual int getbyte(); // -1 if not available
  virtual int putbyte(unsigned char c); // 0 if error

  static int isinput();
  static int isoutput();

  int setuart();
};

#endif
