#include "midiio.hpp"
#include <string.h>
#ifdef __MSDOS__
#include <dir.h>
#include <dos.h>
#ifdef GNDIR
#include "gndir.h"
#endif
#endif

char filename[128];

class MidiFmt : public MidiRead
{
public:
  MidiFmt(const char* filename);
  virtual void error(const char* msg);
};

MidiFmt::MidiFmt(const char* filename) : MidiRead(filename)
{
}

void MidiFmt::error(const char*)
{
}

void midiformat(char* name)
{
MidiFmt r(name);

  if (!r.getf())
  {
    fprintf(stderr, "cannot open %s\n", name);
    return;
  }
  const char* fullname;
#if defined(__MSDOS__) && defined(GNDIR)
  fullname = getlongfilename(name);
  if (!fullname)
    fullname = name;
#else
  fullname = name;
#endif

  if (r.runhead())
    printf("%s: version %d, %d track%s\n",
      fullname, r.version_, r.tracks_, r.tracks_ == 1 ? "" : "s");
  else
    printf("%s: not a valid midi file\n", fullname);
}


int main(int argc, char**argv)
{
  argc--; argv++;

  if (argc == 0)
  {
    printf("usage: midifmt *.mid ...\n");
    return 1;
  }
  while (argc > 0)
  {
    char* midiname = *argv++; argc--;

    strcpy(filename, midiname);
#ifdef __MSDOS__
    char* fp = strrchr(filename, '\\');
    if (fp)
      fp++;
    else
    {
      fp = strrchr(filename, ':');
      if (fp)
	fp++;
      else
	fp = filename;
    }
    struct ffblk ff;
    int done = findfirst(midiname, &ff, 0);
    while (!done)
    {
      strcpy(fp, ff.ff_name);
      midiformat(filename);
      done = findnext(&ff);
    }
#else
    midiformat(filename);
#endif
  }
  return 0;
}