#ifndef _MIDIREAD_
#define _MIDIREAD_

#include <stdio.h>

typedef struct
{
  unsigned short songs, tracks, unitsperbeat;
} MIDIHEAD;

const unsigned long MThd = 0x4D546864ul;
const unsigned long MTrk = 0x4D54726Bul;

int getbyte(FILE*f);
unsigned short getword(FILE* f);
unsigned long gettri(FILE* f);
unsigned long getlong(FILE* f);

void putbyte(FILE* f, int n);
void putword(FILE* f, unsigned short n);
void puttri(FILE* f, unsigned long n);
void putlong(FILE* f, unsigned long n);

unsigned long getdelta(FILE* f);
void putdelta(FILE* f, unsigned long n);

int get_midihead(FILE* f, MIDIHEAD* h);
void put_midihead(FILE* f, MIDIHEAD* h);

int get_midicommand(FILE* f, unsigned char* cmd, long len);

void skip_tag(FILE* f);

void open_chunk(FILE* f, char* s);
void close_chunk(FILE* f);

int scanevent(FILE* f,
  unsigned long* dtime,
  unsigned char* ev,
  unsigned char lastev,
  unsigned long* len);

int seekchannel(FILE* f, unsigned long len);

const char* progname(int prog, int channel);

#endif