#include "mtrack.hpp"
#include <string.h>

int main(int argc, char**argv)
{
int verbose = 0;

  argc--; argv++;

  while (argc > 0 && **argv == '-')
  {
    if (strncmp(*argv, "-verbose", 2) == 0)
    {
      verbose = 1;
      argc--; argv++; continue;
    }
    fprintf(stderr, "invalid option %s\n", *argv);
    argc--; argv++;
  }
  if (argc == 0)
  {
    printf("usage: miditrk [-verbose] filename.mid\n");
    return 1;
  }
  char* midiname = *argv++; argc--;

  MidiTrackinfo info(midiname);
  if (info.getf())
  {
    printf("File %s:\n", midiname);
    info.print(stdout, verbose);
  }
  else
  {
    perror(midiname);
    return 1;
  }
  return 0;
}