#include "sndcard.hpp"

#if !defined(NOSB)
#include "sb.hpp"
#endif

#if !defined(NOMPU)
#include "mpu.hpp"
#endif

Soundcard::Soundcard()
{}

Soundcard::~Soundcard()
{}


Soundcard* Soundcard::recognize()
{
  return 0; // not recognized
}

int Soundcard::reset()
{
  return 1;
}

void Soundcard::startinput()
{}

void Soundcard::stopinput()
{}

int Soundcard::hear(unsigned char* buf, int maxlen)
{
  return 0; // no midi data available
}

int Soundcard::play(unsigned char* buf, int len)
{
  return 0;
}

Soundcard* detect_soundcard()
{
  Soundcard* card = 0;

#if !defined(NOMPU)
  card = MPU::recognize();
  if (card)
    return card;
#endif

#if !defined(NOSB)
  card = Soundblaster::recognize();
  if (card)
    return card;
#endif
  return 0; // no soundcard detected
}
