#ifndef lint
static char yysccsid[] = "@(#)yaccpar     1.7 (Berkeley) 09/09/90";
#endif
#define YYBYACC 1
/* txt2midi written by Gnter Nagler 1995 (gnagler@ihm.tu-graz.ac.at)*/
static char* version = "txt2midi v1.4 by Gnter Nagler (" __DATE__ ")";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "midiread.hpp"

#ifdef __MSDOS__
#define WRITE_BINARY  "wb"
#define READ_BINARY   "rb"
#define READ_TEXT     "rt"
#define READWRITE_BINARY   "w+b"
#else
#define WRITE_BINARY  "w"
#define READ_BINARY   "r"
#define READ_TEXT     "r"
#define READWRITE_BINARY   "w+"
#endif

void lexstart(char* name);
int yyerror( char* msg );
int yylex();
int yyparse();
void miditext(FILE*f, int tag, char* s);
void midiendtrack(FILE* f);
long log2(long n);
void copybytes(FILE* f, long srcpos, long srclen);
int isactive();
int lastevent = 0xff;
int option_noteoff = 0;
long filesize = 0;
int percent = 0;
int compress = 1;
void needchannel();
void putcode(FILE* f, int code);
void noteon(FILE* f, int note, int vel);
void noteoff(FILE* f, int note, int vel);
void time(long n);

extern char* yytext;
extern long getlinenr();
extern FILE* yyin;
extern FILE* yyout;

unsigned short ntracks = 0;
long ntrackspos = 0;
unsigned long curdelta = 0;
unsigned long sumdelta = 0;
unsigned long clicksperquarter = 192;
unsigned char tact_nom = 4, tact_denom = 4;
unsigned char trackchannel = 0xff;
unsigned char curchannel = 0xff;
unsigned char channel = 0xff;
unsigned char velocyon = 0x7f;
unsigned char velocyoff = 0;
unsigned int  playing = 0xffffU;
unsigned char muting = 1;
unsigned char maketrack = 0;
signed char transpose[16];

typedef struct
{
  char name[80];
  long pos;
  long len;
  long startdelta;  /* deltaval before tact*/
  long enddelta; /* deltaval after last tact*/
  long startsum;
  long endsum;
} MIDIPART;

#define MAXPARTS  10
MIDIPART parts[MAXPARTS];
int partcnt = 0;

typedef union {
  long longv;
  int intv;
  unsigned char bytev;
  float floatv;
} YYSTYPE;
#define _TRACK 257
#define _HEAD 258
#define _VERSION 259
#define _END 260
#define _EVENT 261
#define _METAEVENT 262
#define _SYSEVENT 263
#define _UNIT 264
#define _TEMPO 265
#define _BEATS 266
#define _TRANSPOSE 267
#define _SIGNEDNUMBER 268
#define _NUMBER 269
#define _NOTE 270
#define _NOTEON 271
#define _NOTEOFF 272
#define _TIMES 273
#define _TEXT 274
#define _DIV 275
#define _SEP 276
#define _ENDTACT 277
#define _SEQNUMBER 278
#define _GENERAL_TEXT 279
#define _COPYRIGHT 280
#define _TRACKNAME 281
#define _INSTRUMENT 282
#define _LYRIC 283
#define _MARKER 284
#define _CUEPOINT 285
#define _SMPTEOFS 286
#define _TACT 287
#define _KEY 288
#define _PROGRAM 289
#define _CONTROL 290
#define _VELOCON 291
#define _VELOCOFF 292
#define _LOOP 293
#define _MUTE 294
#define _SOLO 295
#define _PART 296
#define _COPY 297
#define _PRINT 298
#define _BALANCE 299
#define _REVERB 300
#define _CHORUS 301
#define _BRIGHTNESS 302
#define _HOLD 303
#define _EXPRESSION 304
#define _PITCHMODULATION 305
#define _LEFT 306
#define _RIGHT 307
#define _ON 308
#define _OFF 309
#define _CHANGE 310
#define _MODE 311
#define _SONGPOS 312
#define _SONGSELECT 313
#define _COMMON 314
#define _PITCHBENDRANGE 315
#define _POLYAFTERTOUCH 316
#define _AFTERTOUCH 317
#define _PITCHBEND 318
#define _HBANK 319
#define _LBANK 320
#define _BANKA 321
#define _BANKB 322
#define _BANKC 323
#define _BANKD 324
#define _BANKDRUMS 325
#define _GMRESET 326
#define _GSRESET 327
#define _GSEXIT 328
#define _XGRESET 329
#define _PREFIXCHANNEL 330
#define _PREFIXPORT 331
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    5,    1,    2,    2,    6,    6,    7,    7,    8,
    8,    9,    9,   10,   11,   13,   15,   16,    3,   12,
   12,   14,   14,    4,    4,   19,   21,   22,   17,   18,
   18,   20,   20,   23,   23,   24,   24,   24,   27,   28,
   24,   29,   30,   31,   32,   24,   26,   26,   26,   35,
   26,   37,   26,   26,   34,   34,   39,   25,   38,   38,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   42,   40,   43,   40,   44,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   52,   40,   53,   40,
   55,   40,   40,   49,   49,   46,   46,   46,   46,   46,
   51,   51,   54,   54,   47,   47,   47,   48,   48,   48,
   33,   50,   50,   36,   36,   45,   41,   41,   41,   41,
   56,   57,
};
short yylen[] = {                                         2,
    1,    0,    5,    0,    1,    2,    1,    2,    2,    2,
    1,    2,    1,    1,    1,    0,    0,    0,    8,    0,
    2,    0,    2,    2,    1,    0,    0,    0,    8,    0,
    3,    1,    0,    2,    1,    1,    1,    3,    0,    0,
    8,    0,    0,    0,    0,    9,    2,    2,    2,    0,
    3,    0,    4,    1,    1,    1,    0,    3,    0,    3,
    2,    2,    2,    2,    2,    2,    2,    2,   10,    6,
    2,    2,    2,    1,    2,    0,    5,    0,    9,    0,
    8,    1,    1,    1,    1,    2,    3,    2,    2,    1,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    1,
    3,    2,    1,    3,    2,    2,    0,    5,    0,    5,
    0,    5,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    0,    1,    0,    1,    1,    1,    1,    1,    1,
    1,    1,    3,    1,    1,    1,    2,    2,    1,    1,
    1,    1,
};
short yydefred[] = {                                      0,
    0,    0,    0,    1,    0,    0,    7,   14,    0,   11,
   15,    0,   13,   16,    0,    6,   10,   12,    0,    2,
    0,   17,    0,   21,    0,   26,    0,   25,    0,   18,
    0,   24,   23,    0,    0,   27,    0,    0,    0,   19,
   31,    0,    0,   55,   56,    0,    0,    0,    0,    0,
   50,   28,    0,   35,   36,   37,    0,   54,    0,  131,
  134,  135,   52,    0,   47,   48,   42,   39,    0,    0,
    0,   34,   49,    0,    0,    0,  133,   43,    0,   38,
   51,    0,    0,   76,    0,    0,    0,   74,  113,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  100,    0,    0,  103,    0,    0,    0,
    0,    0,    0,  116,  117,  118,  119,  120,   82,   83,
   85,   84,    0,    0,   58,   90,   53,   44,    0,   29,
   60,    0,    0,    0,   73,    0,  115,  114,    0,    0,
   61,   62,   63,   64,   65,   66,   67,   68,    0,    0,
   75,  136,   86,    0,  127,  125,  126,   91,   93,   94,
   95,  130,  128,  129,   92,   96,   97,   98,    0,  102,
   99,    0,  105,  106,   88,   89,   71,   72,    0,    0,
  141,  142,    0,  139,  140,    0,    0,  121,  107,  109,
  123,  111,    0,    0,   87,  101,  104,    0,    0,    0,
  137,  138,    0,   80,    0,    0,    0,    0,    0,    0,
    0,   77,   78,    0,  108,  110,  112,    0,    0,    0,
   41,    0,    0,    0,   70,   46,    0,    0,    0,    0,
   81,    0,   79,    0,   69,
};
short yydgoto[] = {                                       3,
    4,    5,   15,   27,   23,    6,    7,    9,   12,   10,
   13,   22,   19,   30,   25,   34,   28,   36,   31,   52,
   39,   71,   53,   54,   55,   56,   79,  190,   78,  138,
  189,  220,   57,   58,   70,   63,   76,   75,   59,  135,
  193,  142,  232,  224,  163,  136,  168,  175,  149,   60,
  199,  215,  216,  202,  217,  194,  195,
};
short yysindex[] = {                                   -267,
 -240, -226,    0,    0, -212, -267,    0,    0, -240,    0,
    0, -226,    0,    0, -267,    0,    0,    0, -206,    0,
 -213,    0, -186,    0, -191,    0, -186,    0, -182,    0,
   77,    0,    0, -139, -145,    0, -129,   89, -151,    0,
    0, -236, -144,    0,    0, -137, -136, -135, -138, -161,
    0,    0, -151,    0,    0,    0, -242,    0,   46,    0,
    0,    0,    0, -131,    0,    0,    0,    0, -126, -242,
 -121,    0,    0, -120, -221, -242,    0,    0, -151,    0,
    0, -114,   57,    0, -118,  112, -116,    0,    0, -115,
 -233, -233, -113, -119, -112, -111, -110, -109, -108, -107,
 -101,  -96,  -92,  -86,  -85, -192,  -66,  -65,  -54, -254,
  -52,  -24,  -21,    0,  -15,  -14,    0,  -13, -233,  -12,
  -11,    3,    4,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    5,    6,    0,    0,    0,    0, -151,    0,
    0, -263,  118,    7,    0,    8,    0,    0,    8,    9,
    0,    0,    0,    0,    0,    0,    0,    0,  160,  -25,
    0,    0,    0,   10,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   18,    0,
    0,   20,    0,    0,    0,    0,    0,    0, -151,   30,
    0,    0, -253,    0,    0,   48,  279,    0,    0,    0,
    0,    0,   58,   59,    0,    0,    0, -151,   26,   65,
    0,    0,  288,    0, -242, -242, -242,  272,   75,   85,
   72,    0,    0, -263,    0,    0,    0,   78,   79,   56,
    0, -263, -251,  292,    0,    0, -250,   88,   91,   99,
    0,  304,    0,  120,    0,
};
short yyrindex[] = {                                    134,
    0,    0,    0,    0,    0, -146,    0,    0, -219,    0,
    0, -172,    0,    0,  137,    0,    0,    0, -238,    0,
    0,    0,    0,    0,  138,    0,  399,    0,    0,    0,
  -91,    0,    0,    0,    0,    0,    0,    0,  -19,    0,
    0,    0, -264,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   53,    0,    0,    0,    0,    0,  339,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  268,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  125,    0,
    0,    0,    0,    0,    0, -157,    0,    0, -157, -149,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  268,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  197,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,  385,    0,    0,    0,    0,  395,    0,    0,  393,
  404,    0,    0,    0,    0,    0,  390,    0,    0,    0,
    0,    0,  -76,  -51,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -56,    0,    0,    0,    0,    0,    0,
 -207,    0,    0,    0,    0,    0,    0,    0,  -88,  328,
  270,    0,    0,    0,    0, -185, -163,
};
#define YYTABLESIZE 670
short yytable[] = {                                      30,
   73,   72,  139,  150,  132,  191,  210,  211,  238,  240,
  192,  132,  132,   81,  172,  191,  233,  191,  191,  137,
  192,   20,  192,  192,  237,   20,    1,    2,    8,  212,
  182,   61,   62,   44,   45,  147,  148,    8,    8,   84,
   85,   86,   11,   87,   88,   14,   89,  211,   90,   91,
   92,  211,   21,  173,  174,   24,   93,   94,   95,   96,
   97,   98,   99,  100,  101,  102,  103,  104,  105,  212,
   26,   57,   29,  212,    8,    8,  165,  106,  107,  108,
  109,  110,  111,  112,    9,    9,   33,   72,  113,  114,
  115,  116,  117,  118,  119,  120,  121,  122,  123,  124,
  125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
    5,    5,  208,  166,  167,   42,   35,   43,  122,  122,
   37,    9,    9,   38,   44,   45,  124,  124,   40,   41,
   64,   65,   66,   67,   69,   68,   74,   77,   82,   46,
   47,   48,  140,   57,   49,   50,   51,   80,   83,  141,
  143,  144,  145,   43,  152,  151,   72,  196,  225,  226,
  227,  153,  154,  155,  156,  157,  158,  159,   30,   30,
   30,   30,  160,   30,   30,   30,   30,   30,   30,   30,
   30,  161,  162,  164,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,   30,  169,  170,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,  171,   57,  176,  203,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   33,   57,   57,   57,  177,   57,   57,  178,   57,  204,
   57,   57,   57,  179,  180,  181,  183,  184,   57,   57,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,  185,  186,  187,  188,  197,  198,  201,  205,   57,
   57,   57,   57,   57,   57,   57,  206,   57,  207,  209,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   32,   57,   57,   57,  213,   57,   57,  214,
   57,  221,   57,   57,   57,  222,  218,  219,  223,  228,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,  229,  230,  231,  234,  235,  236,  239,
  241,   57,   57,   57,   57,   57,   57,   57,   57,  242,
  243,  244,   57,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   40,   57,   57,   57,  245,   57,
   57,    4,   57,    4,   57,   57,   57,   22,    3,   20,
   16,   17,   57,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   18,   32,  146,  200,    0,
    0,    0,    0,   57,   57,   57,   57,   57,   57,   57,
    0,    0,    0,    0,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   45,   57,   57,   57,
    0,   57,   57,    0,   57,    0,   57,   57,   57,    0,
    0,    0,    0,    0,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   57,    0,    0,    0,
    0,    0,    0,    0,    0,   57,   57,   57,   57,   57,
   57,   57,    0,    0,    0,    0,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,    0,   57,   57,    0,   57,    0,   57,   57,   57,
    0,    0,    0,    0,    0,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   57,   57,    0,    0,
    0,    0,    0,    0,    0,    0,   57,   57,   57,   57,
   57,   57,   57,    0,    0,    0,    0,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   59,
   59,   59,    0,   59,   59,    0,   59,    0,   59,   59,
   59,    0,    0,    0,    0,    0,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,   59,    0,
    0,    0,    0,    0,    0,    0,    0,   59,   59,   59,
   59,   59,   59,   59,    0,    0,    0,    0,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
};
short yycheck[] = {                                      91,
   57,   53,   79,   92,  269,  269,  260,  193,  260,  260,
  274,  276,  277,   70,  269,  269,  224,  269,  269,   76,
  274,  260,  274,  274,  232,  264,  294,  295,  269,  193,
  119,  268,  269,  276,  277,  269,  270,  257,  258,  261,
  262,  263,  269,  265,  266,  258,  268,  233,  270,  271,
  272,  237,  259,  308,  309,  269,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  233,
  257,   91,  264,  237,  294,  295,  269,  299,  300,  301,
  302,  303,  304,  305,  257,  258,  269,  139,  310,  311,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
  257,  258,  189,  306,  307,  267,   40,  269,  276,  277,
  260,  294,  295,  269,  276,  277,  276,  277,  258,   41,
  275,  269,  269,  269,  296,  274,   91,  269,  260,  291,
  292,  293,  257,   91,  296,  297,  298,  274,  269,   93,
  269,   40,  269,  269,  274,  269,  208,   40,  215,  216,
  217,  274,  274,  274,  274,  274,  274,  269,  260,  261,
  262,  263,  269,  265,  266,  267,  268,  269,  270,  271,
  272,  274,  269,  269,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  269,  269,  296,  297,  298,  299,  300,  301,
  302,  303,  304,  305,  269,   91,  269,   58,  310,  311,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
  260,  261,  262,  263,  269,  265,  266,  269,  268,  275,
  270,  271,  272,  269,  269,  269,  269,  269,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  269,  269,  269,  269,  269,  269,  269,  269,  299,
  300,  301,  302,  303,  304,  305,  269,   91,  269,  260,
  310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  260,  261,  262,  263,  269,  265,  266,   41,
  268,  296,  270,  271,  272,  261,  269,  269,   41,   58,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  269,  260,  274,  269,  269,  293,   58,
  263,  299,  300,  301,  302,  303,  304,  305,   91,  269,
  262,   58,  310,  311,  312,  313,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  260,  261,  262,  263,  269,  265,
  266,  258,  268,  257,  270,  271,  272,  260,    0,   15,
    6,    9,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,   12,   27,   90,  149,   -1,
   -1,   -1,   -1,  299,  300,  301,  302,  303,  304,  305,
   -1,   -1,   -1,   -1,  310,  311,  312,  313,  314,  315,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  260,  261,  262,  263,
   -1,  265,  266,   -1,  268,   -1,  270,  271,  272,   -1,
   -1,   -1,   -1,   -1,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,  300,  301,  302,  303,
  304,  305,   -1,   -1,   -1,   -1,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  261,  262,
  263,   -1,  265,  266,   -1,  268,   -1,  270,  271,  272,
   -1,   -1,   -1,   -1,   -1,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,  300,  301,  302,
  303,  304,  305,   -1,   -1,   -1,   -1,  310,  311,  312,
  313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,  331,  261,
  262,  263,   -1,  265,  266,   -1,  268,   -1,  270,  271,
  272,   -1,   -1,   -1,   -1,   -1,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,  300,  301,
  302,  303,  304,  305,   -1,   -1,   -1,   -1,  310,  311,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
};
#define YYFINAL 3
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 331
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"':'",0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"_TRACK",
"_HEAD","_VERSION","_END","_EVENT","_METAEVENT","_SYSEVENT","_UNIT","_TEMPO",
"_BEATS","_TRANSPOSE","_SIGNEDNUMBER","_NUMBER","_NOTE","_NOTEON","_NOTEOFF",
"_TIMES","_TEXT","_DIV","_SEP","_ENDTACT","_SEQNUMBER","_GENERAL_TEXT",
"_COPYRIGHT","_TRACKNAME","_INSTRUMENT","_LYRIC","_MARKER","_CUEPOINT",
"_SMPTEOFS","_TACT","_KEY","_PROGRAM","_CONTROL","_VELOCON","_VELOCOFF","_LOOP",
"_MUTE","_SOLO","_PART","_COPY","_PRINT","_BALANCE","_REVERB","_CHORUS",
"_BRIGHTNESS","_HOLD","_EXPRESSION","_PITCHMODULATION","_LEFT","_RIGHT","_ON",
"_OFF","_CHANGE","_MODE","_SONGPOS","_SONGSELECT","_COMMON","_PITCHBENDRANGE",
"_POLYAFTERTOUCH","_AFTERTOUCH","_PITCHBEND","_HBANK","_LBANK","_BANKA",
"_BANKB","_BANKC","_BANKD","_BANKDRUMS","_GMRESET","_GSRESET","_GSEXIT",
"_XGRESET","_PREFIXCHANNEL","_PREFIXPORT",
};
char *yyrule[] = {
"$accept : start",
"start : midisong",
"$$1 :",
"midisong : songoptions midihead songoptions $$1 miditracks",
"songoptions :",
"songoptions : optionlist",
"optionlist : optionlist songoption",
"optionlist : songoption",
"songoption : _MUTE mutechannels",
"songoption : _SOLO solochannels",
"mutechannels : mutechannels mutechannel",
"mutechannels : mutechannel",
"solochannels : solochannels solochannel",
"solochannels : solochannel",
"mutechannel : _NUMBER",
"solochannel : _NUMBER",
"$$2 :",
"$$3 :",
"$$4 :",
"midihead : _HEAD $$2 version $$3 unit $$4 _END _HEAD",
"version :",
"version : _VERSION _NUMBER",
"unit :",
"unit : _UNIT _NUMBER",
"miditracks : miditracks miditrack",
"miditracks : miditrack",
"$$5 :",
"$$6 :",
"$$7 :",
"miditrack : _TRACK $$5 channel $$6 opt_midievents $$7 _END _TRACK",
"channel :",
"channel : '(' _NUMBER ')'",
"opt_midievents : midievents",
"opt_midievents :",
"midievents : midievents event",
"midievents : event",
"event : timeevent",
"event : option",
"event : _COPY _PART _TEXT",
"$$8 :",
"$$9 :",
"event : _PART _TEXT $$8 midievents $$9 _END _PART _TEXT",
"$$10 :",
"$$11 :",
"$$12 :",
"$$13 :",
"event : _LOOP _NUMBER $$10 $$11 $$12 midievents $$13 _END _LOOP",
"option : _VELOCON _NUMBER",
"option : _VELOCOFF _NUMBER",
"option : pause sep",
"$$14 :",
"option : _PRINT $$14 sep",
"$$15 :",
"option : _TRANSPOSE transp $$15 sep",
"option : sep",
"sep : _SEP",
"sep : _ENDTACT",
"$$16 :",
"timeevent : $$16 eventchannel midievent",
"eventchannel :",
"eventchannel : '[' _NUMBER ']'",
"midievent : _SEQNUMBER _NUMBER",
"midievent : _GENERAL_TEXT _TEXT",
"midievent : _COPYRIGHT _TEXT",
"midievent : _TRACKNAME _TEXT",
"midievent : _INSTRUMENT _TEXT",
"midievent : _LYRIC _TEXT",
"midievent : _MARKER _TEXT",
"midievent : _CUEPOINT _TEXT",
"midievent : _SMPTEOFS _NUMBER ':' _NUMBER ':' _NUMBER ':' _NUMBER ':' _NUMBER",
"midievent : _TACT _NUMBER _DIV _NUMBER _NUMBER _NUMBER",
"midievent : _PREFIXCHANNEL _NUMBER",
"midievent : _PREFIXPORT _NUMBER",
"midievent : _TEMPO _NUMBER",
"midievent : _BEATS",
"midievent : _KEY _TEXT",
"$$17 :",
"midievent : _EVENT $$17 bytes _END _EVENT",
"$$18 :",
"midievent : _METAEVENT _NUMBER '(' _NUMBER ')' $$18 bytes _END _METAEVENT",
"$$19 :",
"midievent : _SYSEVENT '(' _NUMBER ')' $$19 bytes _END _SYSEVENT",
"midievent : _GMRESET",
"midievent : _GSRESET",
"midievent : _XGRESET",
"midievent : _GSEXIT",
"midievent : _PROGRAM program",
"midievent : _CONTROL _NUMBER _NUMBER",
"midievent : _HBANK _NUMBER",
"midievent : _LBANK _NUMBER",
"midievent : bank",
"midievent : _BALANCE balance",
"midievent : _HOLD onoff",
"midievent : _REVERB _NUMBER",
"midievent : _CHORUS _NUMBER",
"midievent : _BRIGHTNESS _NUMBER",
"midievent : _EXPRESSION _NUMBER",
"midievent : _PITCHMODULATION _NUMBER",
"midievent : _CHANGE _NUMBER",
"midievent : _PITCHBENDRANGE _NUMBER",
"midievent : _MODE",
"midievent : _SONGPOS _NUMBER _NUMBER",
"midievent : _SONGSELECT _NUMBER",
"midievent : _COMMON",
"midievent : _POLYAFTERTOUCH note _NUMBER",
"midievent : _AFTERTOUCH _NUMBER",
"midievent : _PITCHBEND _NUMBER",
"$$20 :",
"midievent : _NOTE duration velocyon $$20 sep",
"$$21 :",
"midievent : _NOTEON note velocyon $$21 sep",
"$$22 :",
"midievent : _NOTEOFF note velocyoff $$22 sep",
"midievent : _SIGNEDNUMBER",
"note : _NOTE",
"note : _NUMBER",
"bank : _BANKA",
"bank : _BANKB",
"bank : _BANKC",
"bank : _BANKD",
"bank : _BANKDRUMS",
"velocyon : _NUMBER",
"velocyon :",
"velocyoff : _NUMBER",
"velocyoff :",
"balance : _LEFT",
"balance : _RIGHT",
"balance : _NUMBER",
"onoff : _ON",
"onoff : _OFF",
"onoff : _NUMBER",
"pause : duration",
"duration : _NUMBER",
"duration : _NUMBER _DIV _NUMBER",
"transp : _SIGNEDNUMBER",
"transp : _NUMBER",
"program : _NUMBER",
"bytes : bytes byte",
"bytes : bytes string",
"bytes : byte",
"bytes : string",
"byte : _NUMBER",
"string : _TEXT",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 600
#define YYMAXDEPTH 600
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE

char* infile = 0;
char* outfile = 0;

int main(int argc, char**argv)
{
  argc--; argv++;

  while (argc > 0 && **argv == '-')
  {
    if (strncmp(*argv, "-version", 2) == 0)
    {
      fprintf(stderr, "%s\n", version);
      argc--; argv++;
      if (argc == 0)
	return 0;
      continue;
    }
    fprintf(stderr, "invalid option %s\n", *argv);
    argc--; argv++;
  }
  if (argc < 2)
  {
    fprintf(stderr, "usage: txt2midi [-version] textfile.txt midifile.mid\n");
    return 1;
  }

  yyin = fopen(infile = *argv++, READ_TEXT); argc--;
#ifdef __MSDOS__
    strlwr(infile);
#endif
  if (!yyin)
  {
    perror(infile);
    return 1;
  }
  fseek(yyin, 0L, SEEK_END);
  filesize = ftell(yyin);
  fseek(yyin, 0L, SEEK_SET);

  if (argc == 0)
    yyout = 0;
  else
  {
    outfile = *argv++; argc--;
#ifdef __MSDOS__
    strlwr(outfile);
#endif
    if (strcmp(infile, outfile) == 0)
    {
      yyout = 0;
      fprintf(stderr, "input and output files are identical!\n");
    }
    else
    {
      yyout = fopen(outfile, READ_BINARY);
      if (yyout)
      {
      MIDIHEAD h;
      int ismidi;

	// test if it is a midi

	ismidi = get_midihead(yyout, &h);
	fclose(yyout);
	if (!ismidi)
	{
	  fprintf(stderr, "cannot overwrite existing file %s\n", outfile);
	  return 1;
	}
      }
      yyout = fopen(outfile, READWRITE_BINARY);
      if (!yyout)
      {
	perror(outfile);
	return 1;
      }
    }
  }
  lexstart(infile);
  yyparse();

  if (percent < 100 && ftell(yyin) >= filesize)
    fprintf(stderr, "%d\r", percent = 100);
  if (yyin)
    fclose(yyin);
  if (yyout)
    fclose(yyout);
  return 0;
}

void errormsg(char* msg)
{
  fprintf(stderr, "Line %ld at '%s': %s\n", getlinenr(), yytext, msg );
  if (strncmp(msg, "invalid program", 15) == 0)
  {
  int i;

    fprintf(stderr, "valid program names are: \n");
    fprintf(stderr, "A11-D88, Dr1-Dr8, 0-127\n");
    for (i = 0; i < 128; i++)
    {
      fprintf(stderr, "%s", progname(i, 0));
      if (i % 8 != 7)
	fputc(' ', stderr);
      else
	fputc('\n', stderr);
    }
  }
  if (yyout)
  {
    fclose(yyout);
    if (outfile && *outfile)
      unlink(outfile);
  }
}

int yyerror( char* msg )
{
  errormsg(msg);
  exit(1);
  return 1;
}

void miditext( FILE* f, int tag, char* s )
{
int len;

  if (isactive())
  {
    putcode(f, 0xff);
    putbyte(f, tag);
    putdelta(f, len = strlen(s));
    if (len > 0)
      fwrite(s, 1, len, f);
  }
}

void midiendtrack(FILE* f)
{
  putcode(f, 0xff);
  putbyte(f, 0x2f);
  putdelta(f, 0); // end of track
}

long log2(long n)
{
long l = 0;

  while (n > 1)
  {
    n /= 2;
    l++;
  }
  return l;
}

void copybytes(FILE* f, long srcpos, long srclen)
{
long dstpos = ftell(f);
char s[512];
int n,r = 0;

  while (srclen > 0)
  {
    n = 512;
    if (srclen < n)
      n = (int)srclen;
    fseek(f, srcpos, SEEK_SET);
    r = fread(s, 1, n, f);
    if (r <= 0)
    {
      yyerror("cannot read midi file");
      return;
    }
    srcpos += r;
    srclen -= r;
    fseek(f, dstpos, SEEK_SET);
    n = fwrite(s, 1, r, f);
    dstpos += n;
  }
}

int isactive()
{
  if (!maketrack)
    return 0;
  if (trackchannel <= 15)   // single channel tracks
    return playing & (1 << trackchannel);
  if (trackchannel == 0xff) // multi channel track
  {
    if (curchannel == 0xff) // not used yet
      return 1;
    return playing & (1 << curchannel);
  }
  return 0;
}

void copypart(FILE* f, MIDIPART* part, unsigned long *curdelta, unsigned long *sumdelta)
{
long d, pos, ppos, len;

  pos = ftell(f);

  if (pos > part->pos)
  {
    fseek(yyout, part->pos, SEEK_SET);
    d = getdelta(yyout);
    ppos = ftell(yyout);
    len = part->len - (ppos-part->pos);
    fseek(yyout, pos, SEEK_SET);
    if (len > 0)
    {
      putdelta(f, *curdelta + d - part->startdelta);
      *sumdelta += part->endsum-part->startsum + *curdelta - part->startdelta;
      *curdelta = part->enddelta;
      copybytes(yyout, ppos, len);
    }
  }
}

void initpart(MIDIPART& p, char* name)
{
  strcpy(p.name, name);
  p.pos = -1;
  p.startdelta = p.enddelta = -1;
  p.startsum = p.endsum = 0;
  p.len = 0;
}

int findpart(char* name)
{
int i;

  for (i = 0; i < partcnt; i++)
    if (strcmp(parts[i].name, name) == 0)
      return i;
  return -1;
}

int allocpart(char* name)
{
int i;

  i = findpart(name);
  if (i >= 0)
  {
  char msg[80];

    sprintf(msg, "duplicate part name %s", name);
    yyerror(msg);
    return -1;
  }
  for (i = 0; i < partcnt; i++)
    if (parts[i].name[0] == 0)
      break;

  if (i == partcnt)
  {
    if (partcnt < MAXPARTS)
      i = partcnt++;
    else
      return -1;
  }

  initpart(parts[i], name);
  return i;
}

void copypart(FILE* f, char* partname, unsigned long *curdelta, unsigned long *sumdelta)
{
int i;

  i = findpart(partname);
  if (i >= 0)
  {
    copypart(f, &parts[i], curdelta, sumdelta);
  }
  else
  {
  char msg[80];

    sprintf(msg, "part not defined %s", partname);
    yyerror(msg);
  }
}

void putcode(FILE* f, int code)
{
int put;

  time(curdelta);

  if (compress)
    put = !(code == lastevent && code <= 0x9f);
  else
    put = 1;
  if (put)
    putbyte(f, code);
  lastevent = code;
}

void noteoff(FILE* f, int note, int vel)
{
  if (vel != 0 || option_noteoff)
    putcode(f, 0x80+channel);
  else
    putcode(f, 0x90+channel);
  putbyte(f, (unsigned char)note);
  putbyte(f, (unsigned char)vel);
}


void noteon(FILE* f, int note, int vel)
{
  putcode(f, 0x90+channel);
  putbyte(f, (unsigned char)note);
  putbyte(f, (unsigned char)vel);
}

void time(long n)
{
  putdelta(yyout, n);
  sumdelta += n;
  curdelta = 0;
}

void needchannel()
{
static int hint = 0;

  if (channel >= 0 && channel <= 15)
    return;
  errormsg("midi command missing channel number (1-16), using default channel 1");
  channel = 0;
  if (!hint)
  {
    hint = 1;
    printf("Info: set track channel using `mtrk(channel)` or set event channel using [channel]\n");
  }
}
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if ((yys = "1") != 0)       
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 2:
{
    memset(transpose, 0, sizeof(transpose));
  }
break;
case 3:
{
    fseek(yyout, ntrackspos, SEEK_SET);
    putword(yyout, ntracks);
  }
break;
case 14:
{
    playing &= ~(1 << ((yyvsp[0].longv-1) & 15));
    muting = 1;
  }
break;
case 15:
{
    if (muting)
      playing = 0;
    playing |= (1 << ((yyvsp[0].longv-1) & 15));
    muting = 0;
  }
break;
case 16:
{
    open_chunk(yyout, "MThd");
  }
break;
case 17:
{
    putword(yyout, (int)yyvsp[0].longv);  /* midi version*/
    ntrackspos = ftell(yyout);
    putword(yyout, ntracks);
  }
break;
case 18:
{
    clicksperquarter = yyvsp[0].longv;
    putword(yyout, (unsigned short) yyvsp[0].longv);
    close_chunk(yyout);
  }
break;
case 20:
{ yyval.longv = 1; }
break;
case 21:
{ yyval = yyvsp[0];
      if (yyvsp[0].longv != 0 && yyvsp[0].longv != 1 && yyvsp[0].longv != 2)
	yyerror("invalid version number: only 0,1,2 are supported");
    }
break;
case 22:
{ yyval.longv = 192; }
break;
case 23:
{ yyval = yyvsp[0]; }
break;
case 26:
{
    curdelta = sumdelta = 0;
    partcnt = 0;
  }
break;
case 27:
{
    maketrack = 1;
    if (isactive())
    {
      open_chunk(yyout, "MTrk");
      maketrack = 1;
    }
    else
      maketrack = 0;
    lastevent = 0xff;
  }
break;
case 28:
{
    if (maketrack)
    {
      midiendtrack(yyout);
      close_chunk(yyout);
      ntracks++;
      maketrack = 0;
    }
  }
break;
case 30:
{ trackchannel = channel = curchannel = 0xff; }
break;
case 31:
{
      curchannel = (unsigned char)((yyvsp[-1].longv-1) & 15);
      if (yyvsp[-1].longv < 1 || yyvsp[-1].longv > 16)
      {
	errormsg("channel out of range 1-16");
	curchannel = 0;
      }
     trackchannel = channel = curchannel;
   }
break;
case 38:
{
      copypart(yyout, yytext, &curdelta, &sumdelta);
    }
break;
case 39:
{
      yyval.intv = allocpart(yytext);
      if (yyval.intv >= 0)
      {
	parts[yyval.intv].pos = ftell(yyout);
	parts[yyval.intv].startdelta = curdelta;
	parts[yyval.intv].startsum = sumdelta;
      }
    }
break;
case 40:
{
      if (yyvsp[-1].intv >= 0)
      {
	parts[yyvsp[-1].intv].len = ftell(yyout) - parts[yyvsp[-1].intv].pos;
	parts[yyvsp[-1].intv].enddelta = curdelta;
	parts[yyvsp[-1].intv].endsum = sumdelta;
      }
    }
break;
case 41:
{
      if (yyvsp[-5].intv >= 0)
      {
	if (strcmp(parts[yyvsp[-5].intv].name, yytext) != 0)
	{
	char msg[80];

	  sprintf(msg, "end of part %s not found", parts[yyvsp[-5].intv].name);
	  return yyerror(msg);
	}
      }
    }
break;
case 42:
{
      yyval.longv = ftell(yyout);
    }
break;
case 43:
{
      yyval.longv = curdelta;
    }
break;
case 44:
{
      yyval.longv = sumdelta;
    }
break;
case 45:
{

      if (isactive())
      {
      MIDIPART part;
      long i;

	part.name[0] = 0;
	part.pos = yyvsp[-3].longv;
	part.len = ftell(yyout) - yyvsp[-3].longv;
	part.startdelta = yyvsp[-2].longv;
	part.enddelta = curdelta;
	part.startsum = yyvsp[-1].longv;
	part.endsum = sumdelta;

	for (i = 1; i < yyvsp[-4].longv; i++)
	  copypart(yyout, &part, &curdelta, &sumdelta);
      }
    }
break;
case 47:
{ velocyon = (unsigned char)yyvsp[0].longv; }
break;
case 48:
{ velocyoff = (unsigned char)yyvsp[0].longv; }
break;
case 50:
{
    if (isactive())
      printf("Channel %d at %ld (%05lXh)\n", channel+1, sumdelta+curdelta, sumdelta+curdelta);
    }
break;
case 52:
{
      if (curchannel <= 15)
	transpose[curchannel] = (signed char)yyvsp[0].longv;
    }
break;
case 56:
{
    const epsilon = 0;  /* set epsilon to > 0 if small tact errors are allowed*/
    long tactsize = ((4*clicksperquarter*tact_nom) / tact_denom);
    long tactpos = (sumdelta+curdelta) % tactsize;

      if (tactpos == 0)
	;
      else if (tactpos < epsilon)
      {
	/* ok, subtract from curdelta*/
	if (curdelta >= tactpos)
	  curdelta -= tactpos;
	else
	  ; /* not correctable / error in last tact*/
      }
      else if (tactpos >= tactsize-epsilon)
      {
	/* ok, add to curdelta*/

	curdelta += tactsize-tactpos;
      }
      else
      {
	/* error*/
	yyerror("tact error");
      }
    }
break;
case 57:
{
  int newpercent;

    if (filesize <= 0)
      newpercent = 100;
    else
      newpercent = (int) ((ftell(yyin) * 100) / filesize);
    if (newpercent != percent)
      fprintf(stderr, "%d%%\r", percent = newpercent);
  }
break;
case 59:
{ channel = curchannel; }
break;
case 60:
{
      channel = (int)yyvsp[-1].longv-1;
      if (channel < 0 || channel > 15)
      {
	errormsg("event channel out of range 1-16");
	channel = 0;
      }
      if (trackchannel == 0xff || trackchannel == channel)
	curchannel = channel;
      else /* invalid channel */
      {
	yyerror("multiple channels used in single channel track");
	channel = curchannel;
      }
    }
break;
case 61:
{
      if (isactive())
      {
	putcode(yyout, 0xff);
	putbyte(yyout, 0);
	putbyte(yyout, 2);
	putword(yyout, (unsigned short)yyvsp[0].longv);
      }
    }
break;
case 62:
{
      miditext(yyout, 1, yytext);
    }
break;
case 63:
{
      miditext(yyout, 2, yytext);
    }
break;
case 64:
{
      miditext(yyout, 3, yytext);
    }
break;
case 65:
{
      miditext(yyout, 4, yytext);
    }
break;
case 66:
{
      miditext(yyout, 5, yytext);
    }
break;
case 67:
{
      miditext(yyout, 6, yytext);
    }
break;
case 68:
{
      miditext(yyout, 7, yytext);
    }
break;
case 69:
{
      if (isactive())
      {
	putcode(yyout, 0xff);
	putbyte(yyout, 0x54);
	putbyte(yyout, 5); /* length*/
	putbyte(yyout, (unsigned char)yyvsp[-8].longv);
	putbyte(yyout, (unsigned char)yyvsp[-6].longv);
	putbyte(yyout, (unsigned char)yyvsp[-4].longv);
	putbyte(yyout, (unsigned char)yyvsp[-2].longv);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 70:
{
      if (isactive())
      {
	putcode(yyout, 0xff);
	putbyte(yyout, 0x58);
	putbyte(yyout, 4); /* length*/
	putbyte(yyout, tact_nom = (unsigned char)yyvsp[-4].longv);
	putbyte(yyout, (unsigned char)log2(tact_denom = (unsigned char)yyvsp[-2].longv));
	putbyte(yyout, (unsigned char)yyvsp[-1].longv);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 71:
{
      if (isactive())
      {
	putcode(yyout, 0xff);
	putbyte(yyout, 0x20);
	putbyte(yyout, 1);
	putbyte(yyout, (unsigned char)((yyvsp[0].longv-1) & 15));
      }
    }
break;
case 72:
{
      if (isactive())
      {
	putcode(yyout, 0xff);
	putbyte(yyout, 0x21);
	putbyte(yyout, 1);
	putbyte(yyout, (unsigned char)(yyvsp[0].longv & 15));
      }
    }
break;
case 73:
{
      if (isactive())
      {
	putcode(yyout, 0xff);
	putbyte(yyout, 0x51);
	putbyte(yyout, 3);
	puttri(yyout, yyvsp[0].longv);
      }
    }
break;
case 74:
{
      if (isactive())
      {
	putcode(yyout, 0xff);
	putbyte(yyout, 0x51);
	putbyte(yyout, 3);
	if (yyvsp[0].floatv < 1.0)
	{
	  yyerror("beats value is too small (< 1.0)");
	  yyvsp[0].floatv = 120.0; /* default tempo*/
	}
	puttri(yyout, (long)(60000000.0 / yyvsp[0].floatv));
      }
    }
break;
case 75:
{
    int signature = 0, isminor = 0;
    char* s = yytext;

      if (*s == 'C')
      {
	signature = 0;
	s++;
      }
      else if (*s >= '1' && *s <= '7' && strchr("b#", s[1]) != 0)
      {
	signature = *s++ - '0';
	if (*s++ == 'b')
	  signature = -signature;
      }
      else
      {
	yyerror("invalid key signature should be: C or 1-7b 1-7#");
	*s = 0;
      }
      while (isspace(*s))
	s++;
      if (strncmp(s, "major", 3) == 0 || strncmp(s, "Major", 3) == 0)
	isminor = 0;
      else if (strncmp(s, "minor", 3) == 0 || strncmp(s, "Minor", 3) == 0)
	isminor = 1;
      else if (*s)
	yyerror("illegal key signature: missing maj or min");

      if (isactive())
      {
	putcode(yyout, 0xff);
	putbyte(yyout, 0x59);
	putbyte(yyout, 2);
	putbyte(yyout, (unsigned char)signature);
	putbyte(yyout, (unsigned char)isminor);
      }
    }
break;
case 76:
{
      time(curdelta);
    }
break;
case 78:
{ if (isactive())
      {
	putcode(yyout, 0xff);
	if (yyvsp[-3].longv < 0 || yyvsp[-3].longv >= 128)
	  yyerror("invalid metaevent (should be in range 0-127)");
	putbyte(yyout, (unsigned char)yyvsp[-3].longv);
	putdelta(yyout, yyvsp[-1].longv);
      }
    }
break;
case 79:
{
      if (yyvsp[-2].longv != yyvsp[-5].longv)
	yyerror("invalid length specified in metaevent");
    }
break;
case 80:
{ if (isactive())
	putcode(yyout, 0xf0);
    }
break;
case 81:
{ if (isactive())
       putbyte(yyout, 0xf7);
      if (yyvsp[-2].longv != yyvsp[-5].longv)
	yyerror("invalid length specified in sysevent");
    }
break;
case 82:
{ if (isactive())
      {
	/* F0 05 7E 7F 09 01 F7*/

	putcode(yyout, 0xf0);
	putbyte(yyout, 0x05);
	putbyte(yyout, 0x7e);
	putbyte(yyout, 0x7f);
	putbyte(yyout, 0x09);
	putbyte(yyout, 0x01);
	putbyte(yyout, 0xf7);
      }
    }
break;
case 83:
{ if (isactive())
      {
	/* F0 0A 41 10 42 12 40 00 7F 00 41 F7*/

	putcode(yyout, 0xf0);
	putbyte(yyout, 0x0A);
	putbyte(yyout, 0x41);
	putbyte(yyout, 0x10);
	putbyte(yyout, 0x42);
	putbyte(yyout, 0x12);
	putbyte(yyout, 0x40);
	putbyte(yyout, 0x00);
	putbyte(yyout, 0x7f);
	putbyte(yyout, 0x00);
	putbyte(yyout, 0x41);
	putbyte(yyout, 0xf7);
      }
    }
break;
case 84:
{ if (isactive())
      {
	/* F0 08 43 10 4C 00 00 7E 00 F7*/

	putcode(yyout, 0xf0);
	putbyte(yyout, 0x08);
	putbyte(yyout, 0x43);
	putbyte(yyout, 0x10);
	putbyte(yyout, 0x4C);
	putbyte(yyout, 0x00);
	putbyte(yyout, 0x00);
	putbyte(yyout, 0x7e);
	putbyte(yyout, 0x00);
	putbyte(yyout, 0xf7);
      }
    }
break;
case 85:
{ if (isactive())
      {
	/* F0 0A 41 10 42 12 40 00 7F 7F 42 F7*/

	putcode(yyout, 0xf0);
	putbyte(yyout, 0x0A);
	putbyte(yyout, 0x41);
	putbyte(yyout, 0x10);
	putbyte(yyout, 0x42);
	putbyte(yyout, 0x12);
	putbyte(yyout, 0x40);
	putbyte(yyout, 0x00);
	putbyte(yyout, 0x7f);
	putbyte(yyout, 0x7f);
	putbyte(yyout, 0x42);
	putbyte(yyout, 0xf7);
      }
    }
break;
case 86:
{
      if (isactive())
      {
	needchannel();
	putcode(yyout, 0xC0+channel);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 87:
{
      if (isactive())
      {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, (unsigned char)yyvsp[-1].longv);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 88:
{
       if (isactive())
       {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 0x00);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
       }
     }
break;
case 89:
{
       if (isactive())
       {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 0x20);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
       }
     }
break;
case 90:
{
       if (isactive())
       {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 0x00);
	putbyte(yyout, (int)((yyvsp[0].longv >> 8) & 0xff));
	putbyte(yyout, 0x0); /* time*/
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 0x20);
	putbyte(yyout, (int)(yyvsp[0].longv & 0xff));
       }
     }
break;
case 91:
{
      if (isactive())
      {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 10);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 92:
{
      if (isactive())
      {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 0x40);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 93:
{
      if (isactive())
      {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 0x5b);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 94:
{
      if (isactive())
      {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 0x5d);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 95:
{
      if (isactive())
      {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 0x4a);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 96:
{
      if (isactive())
      {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 11);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 97:
{
      if (isactive())
      {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 1);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 98:
{
      if (isactive())
      {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, yyvsp[-1].bytev);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 99:
{
      if (isactive())
      {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 0x65); /* highRPN 0*/
	putbyte(yyout, 0);
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 0x64); /* lowRPN 0*/
	putbyte(yyout, 0);
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, 6); /* data*/
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 100:
{
      if (isactive())
      {
	needchannel();
	putcode(yyout, 0xB0+channel);
	putbyte(yyout, (unsigned char)(yyvsp[0].longv & 0xff));
	putbyte(yyout, (unsigned char)((yyvsp[0].longv >> 8) & 0xff));
      }
    }
break;
case 101:
{
      if (isactive())
      {
	putcode(yyout, 0xF2);
	putbyte(yyout, (unsigned char)(yyvsp[-1].longv & 127));
	putbyte(yyout, (unsigned char)(yyvsp[0].longv & 127));
      }
    }
break;
case 102:
{
      if (isactive())
      {
	putcode(yyout, 0xF3);
	putbyte(yyout, (unsigned char)((yyvsp[0].longv & 127)));
      }
    }
break;
case 103:
{
      if (isactive())
      {
	putcode(yyout, yyvsp[0].bytev);
      }
    }
break;
case 104:
{
      if (isactive())
      {
	putcode(yyout, 0xA0+channel);
	putbyte(yyout, (unsigned char)yyvsp[-1].longv);
	putbyte(yyout, (unsigned char)(yyvsp[0].longv & 127));
      }
    }
break;
case 105:
{
      if (isactive())
      {
	putcode(yyout, 0xD0+channel);
	putbyte(yyout, (unsigned char)(yyvsp[0].longv & 127));
      }
    }
break;
case 106:
{
      if (isactive())
      {
	putcode(yyout, 0xE0+channel);
	putbyte(yyout, (unsigned char)((yyvsp[0].longv & 127)));
	putbyte(yyout, (unsigned char)(((yyvsp[0].longv >> 7) & 127)));
      }
    }
break;
case 107:
{
      if (isactive())
      {
	noteon(yyout, (unsigned char)yyvsp[-2].longv, (unsigned char)yyvsp[0].longv);
	time(yyvsp[-1].longv);
	noteoff(yyout, (unsigned char)yyvsp[-2].longv, 0);
      }
    }
break;
case 109:
{
      if (isactive())
      {
	putcode(yyout, 0x90+channel);
	putbyte(yyout, (unsigned char)yyvsp[-1].longv);
	putbyte(yyout, (unsigned char)yyvsp[0].longv);
      }
    }
break;
case 111:
{
      if (isactive())
	noteoff(yyout, (unsigned char)yyvsp[-1].longv, (unsigned char)yyvsp[0].longv);
    }
break;
case 113:
{
      if (isactive())
      {
	if (yyvsp[0].longv < 0) /* note off*/
	  noteoff(yyout, (unsigned char)(-yyvsp[0].longv), velocyoff);
	else /* note on*/
	  noteon(yyout, (unsigned char)yyvsp[0].longv, velocyon);
      }
    }
break;
case 114:
{ yyval.longv = yyvsp[0].longv + transpose[curchannel]; if (yyval.longv < 0) return yyerror("invalid note"); }
break;
case 115:
{ yyval.longv = yyvsp[0].longv + transpose[curchannel]; if (yyval.longv < 0) return yyerror("invalid note"); }
break;
case 116:
{ yyval.longv = 0x3800; }
break;
case 117:
{ yyval.longv = 0x3800; }
break;
case 118:
{ yyval.longv = 0x0001; }
break;
case 119:
{ yyval.longv = 0x0001; }
break;
case 120:
{ yyval.longv = 0x3E00; }
break;
case 122:
{ yyval.longv = velocyon; }
break;
case 124:
{ yyval.longv = velocyoff; }
break;
case 125:
{ yyval.longv = 0; }
break;
case 126:
{ yyval.longv = 127; }
break;
case 128:
{ yyval.longv = 127; }
break;
case 129:
{ yyval.longv = 0; }
break;
case 131:
{
    curdelta += yyvsp[0].longv;
  }
break;
case 133:
{ yyval.longv = yyvsp[-2].longv * 4 * clicksperquarter / yyvsp[0].longv ; }
break;
case 137:
{ yyval.longv = yyvsp[-1].longv + 1; }
break;
case 138:
{ yyval.longv = yyvsp[-1].longv + yyvsp[0].longv; }
break;
case 139:
{ yyval.longv = 1; }
break;
case 141:
{
    if (isactive())
    {
      putbyte(yyout, (unsigned char)yyvsp[0].longv);
    }
  }
break;
case 142:
{
    if (isactive())
    {
    char* s = yytext;
    int len = 0;

      while (*s)
      {
	putbyte(yyout, *s++);
	len++;
      }
      yyval.longv = len;
    }
    else
      yyval.longv = 0;
  }
break;
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
